Attribute VB_Name = "Module1"
Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

'the following 3 subs are taken from APIMacro.bas (on our web site)
Public Function GetBValue(RGBValue As Long) As Integer
GetBValue = ((RGBValue And &HFF0000) / &H10000) And &HFF
End Function

Public Function GetGValue(RGBValue As Long) As Integer
GetGValue = ((RGBValue And &HFF00) / &H100) And &HFF
End Function

Public Function GetRValue(RGBValue As Long) As Integer
GetRValue = RGBValue And &HFF
End Function

Public Sub DrawGradient(picHDC As Long, StartColor As Long, EndColor As Long, StartPointX As Long, StartPointY As Long, Width As Long, Height As Long)
Dim X As Long, Y As Long, curColor As Long
'step to change color attributes
Dim RStep As Single, GStep As Single, BStep As Single
'specify current color attributes
Dim curR As Single, curG As Single, curB As Single

'init current color attributes to the start color
curR = GetRValue(StartColor)
curG = GetGValue(StartColor)
curB = GetBValue(StartColor)

'avoid error (division by zero) if width is 0
If Width = 0 Then
 RStep = 0
 GStep = 0
 BStep = 0
Else
 'calculate steps
 RStep = (GetRValue(EndColor) - curR) / Width
 GStep = (GetGValue(EndColor) - curG) / Width
 BStep = (GetBValue(EndColor) - curB) / Width
End If

'avoid error caused by rounding single numbers
On Error Resume Next
For X = StartPointX To StartPointX + Width
 curColor = RGB(Int(curR), Int(curG), Int(curB))
 'change value attributes
 curR = curR + RStep
 curG = curG + GStep
 curB = curB + BStep
 For Y = StartPointY To StartPointY + Height
  'set a pixel color
  Call SetPixel(picHDC, X, Y, curColor)
 Next Y
Next X
'reset error handler
On Error GoTo 0
End Sub
